.\"
.\" $XFree86: xc/doc/man/Xi/XGetExtV.man,v 1.5 2006/01/09 14:56:19 dawes Exp $
.\"
.\"
.\" Copyright ([\d,\s]*) by Hewlett-Packard Company, Ardent Computer, 
.\" 
.\" Permission to use, copy, modify, distribute, and sell this documentation 
.\" for any purpose and without fee is hereby granted, provided that the above
.\" copyright notice and this permission notice appear in all copies.
.\" Ardent, and Hewlett-Packard make no representations about the 
.\" suitability for any purpose of the information in this document.  It is 
.\" provided \`\`as is'' without express or implied warranty.
.\" 
.ds xL Programming With Xlib
.TH XGetExtensionVersion 3X11 __vendorversion__ "X FUNCTIONS"
.SH NAME
XGetExtensionVersion \- query the version of the input extension.
.SH SYNTAX
.HP
XExtensionVersion *XGetExtensionVersion\^(\^Display *\fIdisplay\fP\^, char
*\fIname\fP\^); 
.SH ARGUMENTS
.TP 12
.I display
Specifies the connection to the X server.
.TP 12
.I name
Specifies the extension to be queried.  The input extension name is defined
in the header file \fIXI.h\fP.
.SH DESCRIPTION
The \fIXGetExtensionVersion\fP request queries the version of the input 
extension, and returns an \fIXExtensionVersion\fP structure.  This structure
contains a major_version and minor_version number which can be compared
with constants defined in \fIXI.h\fP.  Support for additional protocol 
requests added to the input extension after its initial release is indicated
by a version number corresponding to the added requests.  Each version
contains all the protocol requests contained by previous versions.
.LP
You should use \fIXFree\fP to free the \fIXExtensionVersion\fP structure.
.SH STRUCTURES
This request returns an XExtensionVersion structure.
.DS
typedef struct {
        int   	present;
        short	major_version;
        short	minor_version;
} XExtensionVersion;
.DE
.SH DIAGNOSTICS
none
.SH "SEE ALSO"
.br
\fI\*(xL\fP
