/* $XFree86: xc/programs/Xserver/hw/xfree86/drivers/via/via_refresh.h,v 1.3 2003/08/27 15:16:12 tsi Exp $ */
/*
 * Copyright 1998-2003 VIA Technologies, Inc. All Rights Reserved.
 * Copyright 2001-2003 S3 Graphics, Inc. All Rights Reserved.
 *
 * Permission is hereby granted, free of charge, to any person obtaining a
 * copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sub license,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice (including the
 * next paragraph) shall be included in all copies or substantial portions
 * of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL
 * VIA, S3 GRAPHICS, AND/OR ITS SUPPLIERS BE LIABLE FOR ANY CLAIM, DAMAGES OR
 * OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
 * ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
 * DEALINGS IN THE SOFTWARE.
 */

#ifndef _VIA_REFRESH_H_
#define _VIA_REFRESH_H_ 1

static const int supportRef[] = { 60, 75, 85, 100, 120 };
static const int DDR266[3][17][5] = {
                              /* 8 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 16 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 24, 32 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              }
                          };

static const int DDR200[3][17][5] = {
                              /* 8 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 16 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 24, 32 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1600x1200 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              }
                          };

static const int SDR133[3][17][5] = {
                              /* 8 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 16 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 24, 32 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1600x1200 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              }
                          };

static const  int SDR100[3][17][5] = {
                              /* 8 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 16 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1600x1200 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              },
                              /* 24, 32 bpp */
                              {
                                  /* 640x480 */
                                  { 1,  1,  1,  1,  1 },
                                  /* 800x600 */
                                  { 1,  1,  1,  1,  0 },
                                  /* 1024x768 */
                                  { 1,  1,  1,  0,  0 },
                                  /* 1152x864 */
                                  { 1,  1,  0,  0,  0 },
                                  /* 1280x1024 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1600x1200 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 1440x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x768 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1280x960 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1920x1440 */
                                  { 0,  0,  0,  0,  0 },
                                  /* 848x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1400x1050 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 720x576 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x512 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 856x480 */
                                  { 1,  0,  0,  0,  0 },
                                  /* 1024x576 */
                                  { 1,  0,  0,  0,  0 }
                              }
                          };

#endif /* _VIA_REFRESH_H_ */
